﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.IO;

public partial class Response : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //Value to switch functions on page
        bool debug;
        debug = true;  //set to false to hide stream output labels

        //TODO: Testing to see if cache should be cleared
        //Not sure what happens if user hits back key. Page refresh should be ok.

        if (!Page.IsPostBack)
        {
            if (Request.Form.Keys.Count == 0)
            {
                //No stream, add error handling here.
            }

            if (debug == true)  //diplay some of the key values
            {
                pnlStreamValues.Visible = true;
                //Show the full stream coming in
                Stream s = Request.InputStream;
                StreamReader reader = new StreamReader(s);
                string incoming = reader.ReadToEnd();
                lblStream.Text = incoming;

                //Show the core response key values
                lbl_pg_response_type.Text = Request.Form["pg_response_type"];
                lbl_pg_response_code.Text = Request.Form["pg_response_code"];
                lbl_pg_response_description.Text = Request.Form["pg_response_description"];
            }

            //Page and database actions for payment responses are handled here
            //Note that Type U, F, and E could be handled similarly, so adjust as desired
            //See SWP Integration Guide for all message response codes
            //Currently this page just displays a message based on a result
            string resultMsg;

            switch (Request.Form["pg_response_type"])
            {
                case "A":
                    //code for Appoved Transactions here
                    //You can use the returned "pg_consumerorderid" to update database with approval
                    resultMsg = "Your transaction for $" + Request.Form["pg_total_amount"]
                        + " has been approved. Thank you for your purchase.";

                    lblTransactionResultMsg.Text = resultMsg;
                    break;

                case "U":
                    //code for Declined Transactions here
                    resultMsg = "Your transaction for" + Request.Form["pg_total_amount"]
                        + " was declined. The error message from the card processor was '"
                        + Request.Form["pg_response_description"] + ". Please try your transaction again.";
                    
                    lblTransactionResultMsg.Text = resultMsg;
                    break;

                case "F":
                    //code for Formatting Error here
                    resultMsg = "There was a error during transaction processing. The payment was not completed."
                        + "The error code was: " + Request.Form["pg_resonse_code"] + ": " + Request.Form["pg_response_description"];
                    
                    lblTransactionResultMsg.Text = resultMsg;
                    break;

                case "E":
                    //code for Fatal Exception Responses here
                    resultMsg = "There was a error during transaction processing. The payment was not completed."
                        + "The error code was: " + Request.Form["pg_resonse_code"] + ": " + Request.Form["pg_response_description"];
                    
                    lblTransactionResultMsg.Text = resultMsg;
                    break;

                default:
                    //code does not match.
                    //TODO: Find a graceful way to explode
                    resultMsg = "Error: No data received. Please contact the system administrator.";

                    lblTransactionResultMsg.Text = resultMsg;
                    break;
            }

        }


    }
}
